diff -Naur usbip-0.1.4/src/cmd/stub_server.c trunk/src/cmd/stub_server.c
--- usbip-0.1.4/src/cmd/stub_server.c	2007-05-18 11:10:09.000000000 +0200
+++ trunk/src/cmd/stub_server.c	2007-05-18 11:10:07.000000000 +0200
@@ -1,5 +1,5 @@
 /*
- * Copyright (C) 2005-2006 Takahiro Hirofuchi
+ * Copyright (C) 2005-2007 Takahiro Hirofuchi
  */
 
 #ifdef HAVE_CONFIG_H
@@ -27,12 +27,13 @@
 #include "usbip.h"
 #include "usbip_network.h"
 
+#include <glib.h>
+
 static const char version[] = PACKAGE_STRING
 	" ($Id: stub_server.c 97 2006-03-31 16:08:40Z taka-hir $)";
 
-static struct usbip_stub_driver *StubDriver;
 
-static int send_reply_devlist(struct usbip_stub_driver *driver, int sockfd)
+static int send_reply_devlist(int sockfd)
 {
 	int ret;
 	struct usbip_exported_device *edev;
@@ -42,14 +43,14 @@
 	reply.ndev = 0;
 
 	/* how many devices are exported ? */
-	dlist_for_each_data(driver->edev_list, edev, struct usbip_exported_device) {
+	dlist_for_each_data(stub_driver->edev_list, edev, struct usbip_exported_device) {
 		reply.ndev += 1;
 	}
 
 	dbg("%d devices are exported", reply.ndev);
 
 	ret = usbip_send_op_common(sockfd, OP_REP_DEVLIST,  ST_OK);
-	if(ret < 0) {
+	if (ret < 0) {
 		err("send op_common");
 		return ret;
 	}
@@ -57,12 +58,12 @@
 	PACK_OP_DEVLIST_REPLY(1, &reply);
 
 	ret = usbip_send(sockfd, (void *) &reply, sizeof(reply));
-	if(ret < 0) {
+	if (ret < 0) {
 		err("send op_devlist_reply");
 		return ret;
 	}
 
-	dlist_for_each_data(driver->edev_list, edev, struct usbip_exported_device) {
+	dlist_for_each_data(stub_driver->edev_list, edev, struct usbip_exported_device) {
 		struct usb_device pdu_udev;
 
 		dump_usb_device(&edev->udev);
@@ -70,12 +71,12 @@
 		pack_usb_device(1, &pdu_udev);
 
 		ret = usbip_send(sockfd, (void *) &pdu_udev, sizeof(pdu_udev));
-		if(ret < 0) {
+		if (ret < 0) {
 			err("send pdu_udev");
 			return ret;
 		}
 
-		for(int i=0; i < edev->udev.bNumInterfaces; i++) {
+		for (int i=0; i < edev->udev.bNumInterfaces; i++) {
 			struct usb_interface pdu_uinf;
 
 			dump_usb_interface(&edev->uinf[i]);
@@ -83,7 +84,7 @@
 			pack_usb_interface(1, &pdu_uinf);
 
 			ret = usbip_send(sockfd, (void *) &pdu_uinf, sizeof(pdu_uinf));
-			if(ret < 0) {
+			if (ret < 0) {
 				err("send pdu_uinf");
 				return ret;
 			}
@@ -102,13 +103,13 @@
 	bzero(&req, sizeof(req));
 
 	ret = usbip_recv(sockfd, (void *) &req, sizeof(req));
-	if(ret < 0) {
+	if (ret < 0) {
 		err("recv devlist request");
 		return -1;
 	}
 
-	ret = send_reply_devlist(StubDriver, sockfd);
-	if(ret < 0) {
+	ret = send_reply_devlist(sockfd);
+	if (ret < 0) {
 		err("send devlist reply");
 		return -1;
 	}
@@ -130,25 +131,28 @@
 	bzero(&reply, sizeof(reply));
 
 	ret = usbip_recv(sockfd, (void *) &req, sizeof(req));
-	if(ret < 0) {
+	if (ret < 0) {
 		err("recv import request");
 		return -1;
 	}
 
 	PACK_OP_IMPORT_REQUEST(0, &req);
 
-	dlist_for_each_data(StubDriver->edev_list, edev, struct usbip_exported_device) {
-		if(!strncmp(req.busid, edev->udev.busid, SYSFS_BUS_ID_SIZE)) {
+	dlist_for_each_data(stub_driver->edev_list, edev, struct usbip_exported_device) {
+		if (!strncmp(req.busid, edev->udev.busid, SYSFS_BUS_ID_SIZE)) {
 			dbg("found requested device %s", req.busid);
 			found = 1;
 			break;
 		}
 	}
 
-	if(found) {
+	if (found) {
+		/* should set TCP_NODELAY for usbip */
+		usbip_set_nodelay(sockfd);
+
 		/* export_device needs a TCP/IP socket descriptor */
-		ret = usbip_stub_export_device(StubDriver, edev, sockfd);
-		if(ret < 0) 
+		ret = usbip_stub_export_device(edev, sockfd);
+		if (ret < 0)
 			error = 1;
 	} else {
 		info("not found requested device %s", req.busid);
@@ -157,19 +161,19 @@
 
 
 	ret = usbip_send_op_common(sockfd, OP_REP_IMPORT, (!error ? ST_OK : ST_NA));
-	if(ret < 0) {
+	if (ret < 0) {
 		err("send import reply");
 		return -1;
 	}
 
-	if(!error) {
+	if (!error) {
 		struct usb_device pdu_udev;
 
 		memcpy(&pdu_udev, &edev->udev, sizeof(pdu_udev));
 		pack_usb_device(1, &pdu_udev);
 
 		ret = usbip_send(sockfd, (void *) &pdu_udev, sizeof(pdu_udev));
-		if(ret < 0) {
+		if (ret < 0) {
 			err("send devinfo");
 			return -1;
 		}
@@ -187,14 +191,14 @@
 
 
 	ret = usbip_recv_op_common(sockfd, &code);
-	if(ret < 0) {
+	if (ret < 0) {
 		err("recv op_common, %d", ret);
 		return ret;
 	}
 
 
-	ret = usbip_stub_refresh_device_list(StubDriver);
-	if(ret < 0) 
+	ret = usbip_stub_refresh_device_list();
+	if (ret < 0)
 		return -1;
 
 	switch(code) {
@@ -229,10 +233,10 @@
 
 	ret = getnameinfo(ai->ai_addr, ai->ai_addrlen, hbuf, sizeof(hbuf),
 			sbuf, sizeof(sbuf), NI_NUMERICHOST | NI_NUMERICSERV);
-	if(ret)
+	if (ret)
 		err("getnameinfo, %s", gai_strerror(ret));
 
-	dbg("listen at [%s]:%s", hbuf, sbuf);
+	info("listen at [%s]:%s", hbuf, sbuf);
 }
 
 static struct addrinfo *my_getaddrinfo(char *host, int ai_family)
@@ -242,12 +246,13 @@
 
 	bzero(&hints, sizeof(hints));
 
+	hints.ai_family   = ai_family;
 	hints.ai_socktype = SOCK_STREAM;
 	hints.ai_flags    = AI_PASSIVE;
 
 	ret = getaddrinfo(host, USBIP_PORT_STRING, &hints, &ai_head);
-	if (ret){
-		err("%s: %s", USBIP_PORT_STRING, gai_strerror(ret) );
+	if (ret) {
+		err("%s: %s", USBIP_PORT_STRING, gai_strerror(ret));
 		return NULL;
 	}
 
@@ -255,36 +260,36 @@
 }
 
 #define MAXSOCK 20
-static int listen_all_addrinfo(struct addrinfo *ai_head, int lsock[], int *maxfd)
+static int listen_all_addrinfo(struct addrinfo *ai_head, int lsock[])
 {
 	struct addrinfo *ai;
 	int n = 0;		/* number of sockets */
-	*maxfd = -1;		/* maximum descriptor number */
 
-	for(ai = ai_head; ai && n < MAXSOCK; ai = ai->ai_next){
+	for (ai = ai_head; ai && n < MAXSOCK; ai = ai->ai_next) {
 		int ret;
 
 		lsock[n] = socket(ai->ai_family, ai->ai_socktype, ai->ai_protocol);
-		if(lsock[n] < 0)
+		if (lsock[n] < 0)
 			continue;
 
 		usbip_set_reuseaddr(lsock[n]);
+		usbip_set_nodelay(lsock[n]);
 
-		if(lsock[n] >= FD_SETSIZE){
+		if (lsock[n] >= FD_SETSIZE) {
 			close(lsock[n]);
 			lsock[n] = -1;
 			continue;
 		}
 
 		ret = bind(lsock[n], ai->ai_addr, ai->ai_addrlen);
-		if(ret < 0){
+		if (ret < 0) {
 			close(lsock[n]);
 			lsock[n] = -1;
 			continue;
 		}
 
 		ret = listen(lsock[n], SOMAXCONN);
-		if(ret < 0){
+		if (ret < 0) {
 			close(lsock[n]);
 			lsock[n] = -1;
 			continue;
@@ -292,13 +297,11 @@
 
 		log_addrinfo(ai);
 
-		if(lsock[n] > *maxfd)
-			*maxfd = lsock[n];
-
+		/* next if succeed */
 		n++;
 	}
 
-	if(n == 0){
+	if (n == 0) {
 		err("no socket to listen to");
 		return -1;
 	}
@@ -319,10 +322,10 @@
 	fromhost(&request);
 
 	ret = hosts_access(&request);
-	if(!ret)
+	if (!ret)
 		return -1;
 
-	return 0;	
+	return 0;
 }
 #endif
 
@@ -337,21 +340,23 @@
 	bzero(&ss, sizeof(ss));
 
 	csock = accept(lsock, (struct sockaddr *) &ss, &len);
-	if(csock < 0) {
+	if (csock < 0) {
 		err("accept");
 		return -1;
 	}
 
-	ret = getnameinfo((struct sockaddr *)&ss, len,
+	ret = getnameinfo((struct sockaddr *) &ss, len,
 			host, sizeof(host), port, sizeof(port),
-			NI_NUMERICHOST | NI_NUMERICSERV);
-	if(ret)
+			(NI_NUMERICHOST | NI_NUMERICSERV));
+	if (ret)
 		err("getnameinfo, %s", gai_strerror(ret));
 
 #ifdef HAVE_LIBWRAP
 	ret = tcpd_auth(csock);
-	if(ret < 0) {
-		info("deny %s", host);
+	if (ret < 0) {
+		info("deny access from %s", host);
+		close(csock);
+		return -1;
 	}
 #endif
 
@@ -360,138 +365,123 @@
 	return csock;
 }
 
-static int loop_standalone = 1;
+
+GMainLoop *main_loop;
 
 static void signal_handler(int i)
 {
-	dbg("signal catched %d", i);
-	loop_standalone = 0;
+	dbg("signal catched, code %d", i);
+
+	if (main_loop)
+		g_main_loop_quit(main_loop);
 }
 
-static void daemon_init(void)
+static void set_signal(void)
 {
-	pid_t pid;
+	struct sigaction act;
 
-	usbip_use_stderr = 0;
-	usbip_use_syslog = 1;
+	bzero(&act, sizeof(act));
+	act.sa_handler = signal_handler;
+	sigemptyset(&act.sa_mask);
+	sigaction(SIGTERM, &act, NULL);
+	sigaction(SIGINT, &act, NULL);
+}
 
-	pid = fork();
-	if(pid < 0) {
-		err("fork");
-		exit(EXIT_FAILURE);
-	} else if(pid > 0)
-		/* bye parent */
-		exit(EXIT_SUCCESS);
 
-	setsid();
+gboolean process_comming_request(GIOChannel *gio, GIOCondition condition, gpointer data)
+{
+	int ret;
 
-	signal(SIGHUP, SIG_IGN);
+	if (condition & (G_IO_ERR | G_IO_HUP | G_IO_NVAL))
+		g_error("unknown condition");
 
-	pid = fork();
-	if(pid < 0) {
-		err("fork");
-		exit(EXIT_FAILURE);
-	} else if(pid > 0)
-		/* bye parent */
-		exit(EXIT_SUCCESS);
 
-	chdir("/");
-	umask(0);
+	if (condition & G_IO_IN) {
+		int lsock;
+		int csock;
 
-	for(int i=0; i < 3; i++)
-		close(i);
+		lsock = g_io_channel_unix_get_fd(gio);
 
-}
+		csock = my_accept(lsock);
+		if (csock < 0)
+			return TRUE;
 
-static void set_signal(void)
-{
-	struct sigaction act;
+		ret = recv_pdu(csock);
+		if (ret < 0)
+			err("process recieved pdu");
 
-	bzero(&act, sizeof(act));
-	act.sa_handler = signal_handler;
-	sigemptyset(&act.sa_mask);
-	sigaction(SIGTERM, &act, NULL);
-	sigaction(SIGINT, &act, NULL);
+		close(csock);
+	}
+
+	return TRUE;
 }
 
-static void do_standalone_mode(void)
+
+static void do_standalone_mode(gboolean daemonize)
 {
 	int ret;
 	int lsock[MAXSOCK];
 	struct addrinfo *ai_head;
 	int n;
-	int maxfd;
 
-	if(!usbip_use_debug)
-		daemon_init();
+
+
+	ret = usbip_names_init(USBIDS_FILE);
+	if (ret)
+		err("open usb.ids");
+
+	ret = usbip_stub_driver_open();
+	if (ret < 0)
+		g_error("driver open failed");
+
+	if (daemonize) {
+		if (daemon(0,0) < 0)
+			g_error("daemonizing failed: %s", g_strerror(errno));
+
+		usbip_use_syslog = 1;
+	}
 
 	set_signal();
 
 	ai_head = my_getaddrinfo(NULL, PF_UNSPEC);
-	if(!ai_head)
+	if (!ai_head)
 		return;
 
-	n = listen_all_addrinfo(ai_head, lsock, &maxfd);
-	if(n <= 0) {
+	n = listen_all_addrinfo(ai_head, lsock);
+	if (n <= 0)
 		err("no socket to listen to");
-		goto err;
-	}
 
-	StubDriver = usbip_stub_driver_open();
-	if(!StubDriver) 
-		goto err_driver_open;
+	for (int i = 0; i < n; i++) {
+		GIOChannel *gio;
 
- 	ret = names_init(USBIDS_FILE);
- 	if(ret) 
- 		err("open usb.ids");
+		gio = g_io_channel_unix_new(lsock[i]);
+		g_io_add_watch(gio, (G_IO_IN | G_IO_ERR | G_IO_HUP | G_IO_NVAL),
+				process_comming_request, NULL);
+	}
 
-	info("usbipd start (%s)", version);
 
-	/* setup fd_set */
-	fd_set rfd0;
-	FD_ZERO(&rfd0);
-	for(int i = 0; i < n; i++)
-		FD_SET(lsock[i], &rfd0);
-
-	while(loop_standalone){
-		fd_set rfd = rfd0;
-		ret = select(maxfd + 1, &rfd, NULL, NULL, NULL);
-		if(ret < 0){
-			if(!(errno == EINTR))
-				err("select");
-			break;
-		}
+	info("usbipd start (%s)", version);
 
-		for(int i = 0; i < n; i++){
-			if(FD_ISSET(lsock[i], &rfd)){
-				int csock;
-
-				csock = my_accept(lsock[i]);
-				if(csock < 0)
-					continue;
-
-				ret = recv_pdu(csock);
-				if(ret < 0)
-					err("process recieved pdu");
 
-				close(csock);
-			}
-		}
-	}
+	main_loop = g_main_loop_new(FALSE, FALSE);
+	g_main_loop_run(main_loop);
 
-err:
-	usbip_stub_driver_close(StubDriver);
-err_driver_open:
 	info("shutdown");
+
 	freeaddrinfo(ai_head);
-	names_deinit();
+	usbip_names_free();
+	usbip_stub_driver_close();
+
 	return;
 }
 
 
-const char help_message[] = "\
+static const char help_message[] = "\
 Usage: usbipd [options]				\n\
-	-D, --debug				\n\
+	-D, --daemon				\n\
+		Run as a daemon process.	\n\
+						\n\
+	-d, --debug				\n\
 		Print debugging information.	\n\
 						\n\
 	-v, --version				\n\
@@ -506,14 +496,17 @@
 }
 
 static const struct option longopts[] = {
+	{"daemon",	no_argument,	NULL, 'D'},
+	{"debug",	no_argument,	NULL, 'd'},
 	{"version",	no_argument,	NULL, 'v'},
 	{"help",	no_argument,	NULL, 'h'},
-	{"debug",	no_argument,	NULL, 'D'},
 	{NULL,		0,		NULL,  0}
 };
 
 int main(int argc, char *argv[])
 {
+	gboolean daemonize = FALSE;
+
 	enum {
 		cmd_standalone_mode = 1,
 		cmd_help,
@@ -521,21 +514,23 @@
 	} cmd = cmd_standalone_mode;
 
 
-
 	usbip_use_stderr = 1;
 	usbip_use_syslog = 0;
 
 
-	while(1){
+	for (;;) {
 		int c;
 		int index = 0;
 
-		c = getopt_long(argc, argv, "vhD", longopts, &index);
+		c = getopt_long(argc, argv, "vhdD", longopts, &index);
 
-		if(c == -1)
+		if (c == -1)
 			break;
 
-		switch(c){
+		switch (c) {
+			case 'd':
+				usbip_use_debug = 1;
+				continue;
 			case 'v':
 				cmd = cmd_version;
 				break;
@@ -543,7 +538,7 @@
 				cmd = cmd_help;
 				break;
 			case 'D':
-				usbip_use_debug = 1;
+				daemonize = TRUE;
 				break;
 			case '?':
 				break;
@@ -552,9 +547,9 @@
 		}
 	}
 
-	switch(cmd) {
+	switch (cmd) {
 		case cmd_standalone_mode:
-			do_standalone_mode();
+			do_standalone_mode(daemonize);
 			break;
 		case cmd_version:
 			printf("%s\n", version);
diff -Naur usbip-0.1.4/src/cmd/usbip_network.c trunk/src/cmd/usbip_network.c
--- usbip-0.1.4/src/cmd/usbip_network.c	2007-05-18 11:10:09.000000000 +0200
+++ trunk/src/cmd/usbip_network.c	2007-05-18 11:10:07.000000000 +0200
@@ -1,26 +1,66 @@
 /*
- * Copyright (C) 2005-2006 Takahiro Hirofuchi
+ * Copyright (C) 2005-2007 Takahiro Hirofuchi
  */
 
 #include "usbip_network.h"
 
+void pack_uint32_t(int pack, uint32_t *num)
+{
+	uint32_t i;
+
+	if (pack)
+		i = htonl(*num);
+	else
+		i = ntohl(*num);
+
+	*num = i;
+}
+
+void pack_uint16_t(int pack, uint16_t *num)
+{
+	uint16_t i;
+
+	if (pack)
+		i = htons(*num);
+	else
+		i = ntohs(*num);
+
+	*num = i;
+}
+
+void pack_usb_device(int pack, struct usb_device *udev)
+{
+	pack_uint32_t(pack, &udev->busnum);
+	pack_uint32_t(pack, &udev->devnum);
+	pack_uint32_t(pack, &udev->speed );
+
+	pack_uint16_t(pack, &udev->idVendor );
+	pack_uint16_t(pack, &udev->idProduct);
+	pack_uint16_t(pack, &udev->bcdDevice);
+}
+
+void pack_usb_interface(int pack, struct usb_interface *udev)
+{
+	/* uint8_t members need nothing */
+}
+
 
 static ssize_t usbip_xmit(int sockfd, void *buff, size_t bufflen, int sending)
 {
 	ssize_t total = 0;
 
-	if(!bufflen)
+	if (!bufflen)
 		return 0;
 
 	do {
 		ssize_t nbytes;
 
-		if(sending)
+		if (sending)
 			nbytes = send(sockfd, buff, bufflen, 0);
 		else
 			nbytes = recv(sockfd, buff, bufflen, MSG_WAITALL);
 
-		if(nbytes <= 0)
+		if (nbytes <= 0)
 			return -1;
 
 		buff	= (void *) ((intptr_t) buff + nbytes);
@@ -57,7 +97,7 @@
 	PACK_OP_COMMON(1, &op_common);
 
 	ret = usbip_send(sockfd, (void *) &op_common, sizeof(op_common));
-	if(ret < 0) {
+	if (ret < 0) {
 		err("send op_common");
 		return -1;
 	}
@@ -73,14 +113,14 @@
 	bzero(&op_common, sizeof(op_common));
 
 	ret = usbip_recv(sockfd, (void *) &op_common, sizeof(op_common));
-	if(ret < 0) {
+	if (ret < 0) {
 		err("recv op_common, %d", ret);
 		goto err;
 	}
 
 	PACK_OP_COMMON(0, &op_common);
 
-	if(op_common.version != USBIP_VERSION) {
+	if (op_common.version != USBIP_VERSION) {
 		err("version mismatch, %d %d", op_common.version, USBIP_VERSION);
 		goto err;
 	}
@@ -89,13 +129,13 @@
 		case OP_UNSPEC:
 			break;
 		default:
-			if(op_common.code != *code) {
+			if (op_common.code != *code) {
 				info("unexpected pdu %d for %d", op_common.code, *code);
 				goto err;
 			}
 	}
 
-	if(op_common.status != ST_OK) {
+	if (op_common.status != ST_OK) {
 		info("request failed at peer, %d", op_common.status);
 		goto err;
 	}
@@ -107,40 +147,39 @@
 	return -1;
 }
 
-/* IPv6 ready */
-void usbip_peername(char *host, char *port, int sockfd)
+
+int usbip_set_reuseaddr(int sockfd)
 {
+	const int val = 1;
 	int ret;
 
-	struct sockaddr_storage ss;
-	socklen_t len = sizeof(ss);
+	ret = setsockopt(sockfd, SOL_SOCKET, SO_REUSEADDR, &val, sizeof(val));
+	if (ret < 0)
+		err("setsockopt SO_REUSEADDR");
 
-	bzero(&ss, sizeof(ss));
+	return ret;
+}
 
-	ret = getpeername(sockfd, (struct sockaddr *) &ss, &len);
-	if(ret < 0) {
-		err("getpeername, %s", gai_strerror(ret));
-		return;
+int usbip_set_nodelay(int sockfd)
+{
+	const int val = 1;
+	int ret;
 
-	}
+	ret = setsockopt(sockfd, IPPROTO_TCP, TCP_NODELAY, &val, sizeof(val));
+	if (ret < 0)
+		err("setsockopt TCP_NODELAY");
 
-	ret = getnameinfo((struct sockaddr *)&ss, len,
-			host, sizeof(host), port, sizeof(port),
-			NI_NUMERICHOST | NI_NUMERICSERV);
-
-	if(ret){
-		err("getnameinfo, %s", gai_strerror(ret));
-		return;
-	}
+	return ret;
 }
 
-
-void usbip_set_reuseaddr(int sockfd)
+int usbip_set_keepalive(int sockfd)
 {
 	const int val = 1;
 	int ret;
 
-	ret = setsockopt(sockfd, SOL_SOCKET, SO_REUSEADDR, &val, sizeof(val));
-	if(ret < 0)
-		err("setsockopt");
+	ret = setsockopt(sockfd, SOL_SOCKET, SO_KEEPALIVE, &val, sizeof(val));
+	if (ret < 0)
+		err("setsockopt SO_KEEPALIVE");
+
+	return ret;
 }
diff -Naur usbip-0.1.4/src/cmd/usbip_network.h trunk/src/cmd/usbip_network.h
--- usbip-0.1.4/src/cmd/usbip_network.h	2007-05-18 11:10:09.000000000 +0200
+++ trunk/src/cmd/usbip_network.h	2007-05-18 11:10:06.000000000 +0200
@@ -1,5 +1,5 @@
 /*
- * Copyright (C) 2005-2006 Takahiro Hirofuchi
+ * Copyright (C) 2005-2007 Takahiro Hirofuchi
  */
 
 #ifndef _USBIP_NETWORK_H
@@ -8,6 +8,7 @@
 #include "usbip.h"
 #include <sys/types.h>
 #include <sys/socket.h>
+#include <netinet/tcp.h>
 
 
 /* -------------------------------------------------- */
@@ -24,7 +25,7 @@
 #define OP_REPLY	(0x00 << 8)
 	uint16_t code;
 
-	/* add more error code */ 
+	/* add more error code */
 #define ST_OK	0x00
 #define ST_NA	0x01
 	uint32_t status; /* op_code status (for reply) */
@@ -35,7 +36,7 @@
 	pack_uint16_t(pack, &(op_common)->version);\
 	pack_uint16_t(pack, &(op_common)->code   );\
 	pack_uint32_t(pack, &(op_common)->status );\
-} while(0)
+} while (0)
 
 
 /* ---------------------------------------------------------------------- */
@@ -76,11 +77,11 @@
 } __attribute__((packed));
 
 #define PACK_OP_IMPORT_REQUEST(pack, request)  do {\
-} while(0)
+} while (0)
 
 #define PACK_OP_IMPORT_REPLY(pack, reply)  do {\
 	pack_usb_device(pack, &(reply)->udev);\
-} while(0)
+} while (0)
 
 /* ---------------------------------------------------------------------- */
 /* Negotiate IPSec encryption key. (still not used) */
@@ -118,23 +119,29 @@
 } __attribute__((packed));
 
 #define PACK_OP_DEVLIST_REQUEST(pack, request)  do {\
-} while(0)
+} while (0)
 
 #define PACK_OP_DEVLIST_REPLY(pack, reply)  do {\
 	pack_uint32_t(pack, &(reply)->ndev);\
-} while(0)
+} while (0)
 
 
 /* -------------------------------------------------- */
 /* Declare Prototype Function                         */
 /* -------------------------------------------------- */
 
+void pack_uint32_t(int pack, uint32_t *num);
+void pack_uint16_t(int pack, uint16_t *num);
+void pack_usb_device(int pack, struct usb_device *udev);
+void pack_usb_interface(int pack, struct usb_interface *uinf);
+
 ssize_t usbip_recv(int sockfd, void *buff, size_t bufflen);
 ssize_t usbip_send(int sockfd, void *buff, size_t bufflen);
 int usbip_send_op_common(int sockfd, uint32_t code, uint32_t status);
 int usbip_recv_op_common(int sockfd, uint16_t *code);
-void usbip_peername(char *host, char *port, int sockfd);
-void usbip_set_reuseaddr(int sockfd);
+int usbip_set_reuseaddr(int sockfd);
+int usbip_set_nodelay(int sockfd);
+int usbip_set_keepalive(int sockfd);
 
 #define USBIP_PORT 3240
 #define USBIP_PORT_STRING "3240"
